import Foundation
import FileUtils

class Constants {
    static let repositoryNames = RepositoryNames()
    static let platforms = Platforms()
    static let xamarin = 5
    static let reactNative = 4
    
    // Xamarin
    static let androidBranchForXamarin = "crossplatform/xamarin"
    static let packageIds = PackageIDs()
    static let xamarinAndroidModules = ["instabug-bug": "InstabugAndroidBugSDK", "instabug-chat": "InstabugAndroidChatSDK", "instabug-core": "InstabugAndroidCoreSDK" ,
                                        "instabug-crash": "InstabugAndroidCrashSDK", "instabug-features-request": "InstabugAndroidFeatureRequestSDK", "instabug-survey": "InstabugAndroidSurveySDK"]
    static let xamariniOSModule = "InstabugSDK"
    static let xamariniAndroidMainModule = "InstabugXamarinAndroidSDK"
    static let iOSFramework = "Instabug.framework"
    static let xamarinAPIKey = "oy2kx7wmexi7fhh6bflqe6iqmhynarielb7jollmw2esau"
    
    // React Native
    static let rnGradlePath = "/android/build.gradle"
    static let rnPrivateRepo = "git@github.com:Instabug/instabug-reactnative-private.git"
    static let rnRemoteUrl = "https://github.com/Instabug/Instabug-React-Native"
    static let rnSampleAppUrl = "https://github.com/Instabug/instabug-reactnative/tree/master/InstabugSample"
    static let githubToken = "63ca0a85dc6bd756bbfe6ff43321e5eb46baee3a";
    
    static var cacheDirectoryPath: String = {
        var directory = "~/Library/Application\\ Support/com.instabug.escape/"
        directory = Path.expand(directory)
        
        if Path.exists(directory) == false {
            Directory.create(atPath: directory)
        }
        
        return directory
    }()
    
    static func cacheDirectoryPathFor(platform: String) -> String {
        let repoName = Constants.repositoryNames.repositoryNameFor(platform: platform)
        
        return "\(Constants.cacheDirectoryPath)\(repoName)/"
    }
}

class PackageIDs {
    let androidPackages = ["instabug-bug-for-android": "InstabugAndroidBugSDK", "instabug-chat-for-android": "InstabugAndroidChatSDK", "instabug-core-for-android": "InstabugAndroidCoreSDK", "instabug-crash-for-android": "InstabugAndroidCrashSDK", "instabug-featurerequest": "InstabugAndroidFeatureRequestSDK", "instabug-survey-for-android": "InstabugAndroidSurveySDK"]
    
    let iOS = "instabug-for-ios"
    let mainAndroid = "instabug-for-android"
}

class RepositoryNames {
    let iOS = "Instabug-iOS"
    let android = "android"
    
    func repositoryNameFor(platform: String) -> String {
        let platforms = Platforms()
        
        if platform == platforms.iOS {
            return iOS
        } else {
            return android
        }
    }
}

class Platforms {
    let iOS = "ios"
    let android = "android"
}
